//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <vector>
#include <list>
#include <deque> 
#include <set> 
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  list<int> coll1;
  list<int>::iterator pos1;

  //      1  9
  for (int i=1; i<=9; ++i) {
    coll1.push_back(i);
  }

  //   
  cout << ToRus(" : ");
  for (pos1 = coll1.begin(); pos1 != coll1.end(); ++pos1) {
    cout << *pos1 << ' ';
  }
  cout << endl;

  //    coll1  coll2  
  vector<int> coll2;
  vector<int>::iterator pos2;

  copy (coll1.begin(), coll1.end(), // 
    back_inserter(coll2));  // 

  //   
  cout << ToRus(" : ");
  for (pos2 = coll2.begin(); pos2 != coll2.end(); ++pos2) {
    cout << *pos2 << ' ';
  }
  cout << endl;

  //    ,
  //       
  //  .
  coll2.resize (coll1.size());

  //       
  // -      
  copy (coll1.begin(),coll1.end(),   // 
    coll2.begin()); // 

  //   coll1  ll3    
  // -      
  deque<int> coll3;
  deque<int>::iterator pos3;
  copy (coll1.begin(),coll1.end(),   // 
    front_inserter(coll3)); // 

  //   
  cout << ToRus(" : ");
  for (pos3 = coll3.begin(); pos3 != coll3.end(); ++pos3) {
    cout << *pos3 << ' ';
  }
  cout << endl;

  //   coll1  coll4
  // -   , 
  //   
  set<int> coll4;
  set<int>::iterator pos4;
  copy (coll1.begin(), coll1.end(),  // 
    inserter(coll4,coll4.begin()));  // 

  //   
  cout << ToRus(" : ");
  for (pos4 = coll4.begin(); pos4 != coll4.end(); ++pos4) {
    cout << *pos4 << ' ';
  }
  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
